(function() {
  'use strict';

  var app = {
	registration: null,
	visibleEl: null,
	state: null,

	appName: document.querySelector('.header__title').innerHTML,
    isLoading: true,
	daysOfWeek: ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'],
	months: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'],

	page: document.querySelector('.container'),
	spinner: document.querySelector('.loader'),
    popupBox: document.querySelector('.dialog-container'),
	fsMsg: document.querySelector('.fs-message'),
	toast: document.querySelector('.toast__container'),
	pwahomescreen: document.querySelector('.pwahomescreen'),
	buttonInstall: document.getElementById('installpwa')
  };

  /*****************************************************************************
   *
   * Functions
   *
   ****************************************************************************/

	app.changeView = function(cls = false, title = false) {
		app.hideMenu();

		// spesific actions for page
		switch (cls) {
			case 'switch-page0':
				cls = false;
				title = false;
				break;
			case 'switch-page1':
				
				break;
			case 'switch-page2':
				
				break;
			case 'switch-page3':
				
				break;
		}

		document.querySelector('.header__title').innerHTML = (title ? title : app.appName);
		app.page.setAttribute('class', 'container');

		if (cls) {
			document.querySelector('#btnHome').style.display = 'block';
			document.querySelector('#btnShare').style.display = 'none';

			app.page.classList.add(cls);
			app.visibleEl = '::' + cls;
		}
		else { // home page view
			document.querySelector('#btnHome').style.display = 'none';
			document.querySelector('#btnShare').style.display = 'block';

			app.visibleEl = '::home';
		}
  };

	app.reloadWebApp = function() {
		document.location.reload();
	};

	app.closeFullscreenMsg = function() {
		app.fsMsg.classList.remove('fs-message--visible');

		// trick to remove all listeners
		var el = app.fsMsg.querySelector('.fsm-footer');
		var elClone = el.cloneNode(true);

		el.parentNode.replaceChild(elClone, el);

		app.fsMsg.querySelector('.fsm-footer').setAttribute('hidden', true);

		app.fsMsg.querySelector('.fsm-footer button.btnLeft').setAttribute('hidden', true);
		app.fsMsg.querySelector('.fsm-footer button.btnLeft').innerHTML = 'Action';
		app.fsMsg.querySelector('.fsm-footer button.btnLeft').style.background = '#1a73e8';

		app.fsMsg.querySelector('.fsm-footer button.btnRight').setAttribute('hidden', true);
		app.fsMsg.querySelector('.fsm-footer button.btnRight').innerHTML = 'Action';
		app.fsMsg.querySelector('.fsm-footer button.btnRight').style.background = '#e81a5d';
	};

	app.togglePopupDialog = function(visible = true) {
    if (visible) {
      app.popupBox.classList.add('dialog-container--visible');
    }
    else {
      app.popupBox.classList.remove('dialog-container--visible');
    }
  };

	app.showAboutDialog = function(e) {
		e.preventDefault();
		app.hideMenu();

		app.popupBox.querySelector('.dialog-title').innerHTML = app.appName;
		app.popupBox.querySelector('.dialog-body').innerHTML = 'Aplikasi ini adalah untuk kegunaan <i>Training</i> <b>Progressive Web App</b>.<br><br>Maklumat terkini akan dikemaskini dari semasa ke semasa.<br><br><span style="font-size: 70%;">Icon made by <b>Pixel perfect</b> from www.flaticon.com</span>';

		app.togglePopupDialog(true);
  };

	app.disableContent = function(target, bool = true) {
		var nodes = document.querySelector(target).getElementsByTagName('*');
		for(var i = 0; i < nodes.length; i++){
			nodes[i].disabled = bool;
		}

		if (bool)
			document.querySelector(target).classList.add('disabled');
		else
			document.querySelector(target).classList.remove('disabled');
	}

	// Boilerplate borrowed from https://www.npmjs.com/package/web-push#using-vapid-key-for-applicationserverkey
	app.urlBase64ToUint8Array = function(base64String) {
		const padding = '='.repeat((4 - base64String.length % 4) % 4);
		const base64 = (base64String + padding)
			.replace(/\-/g, '+')
			.replace(/_/g, '/');

		const rawData = window.atob(base64);
		const outputArray = new Uint8Array(rawData.length);

		for (let i = 0; i < rawData.length; ++i) {
			outputArray[i] = rawData.charCodeAt(i);
		}
		return outputArray;
	};

	app.registerPush = async function() {
		toast('To be implemented.');

	};

	app.unregisterPush = function() {
		toast('To be implemented.');

	};

	app.updateSubscriptionToTheServer = async function(subscription) {
		console.info('Updating subscription...');

	};

	app.askPermission = function() {

	};

	app.subWebPush = function() {

	};

	app.installPromotion = function(show = true) {
		app.pwahomescreen.style.display = (show ? 'block' : 'none');
	};

	app.toFixedTwo = function(number, pad) {
    return "00000".substring((number + "").length, pad) + number;
  };

	app.isUrl = function(s) {
		var regexp = /^(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/
		return regexp.test(s.toLowerCase());
	};

  app.isLocalhost = function() {
		// https://stackoverflow.com/questions/53563619/exclude-index-html-from-service-worker-cache-in-create-react-app
		return Boolean(
			window.location.hostname === 'localhost' ||
			// [::1] is the IPv6 localhost address.
			window.location.hostname === '[::1]' ||
			// 127.0.0.1/8 is considered localhost for IPv4.
			window.location.hostname.match(
				/^127(?:\.(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)){3}$/
			)
		);
	};

	app.updateOnlineStatus = function() {

	};

	app.fullscreenMsg = function(msg, title = app.appName, obj = false) {
		app.fsMsg.querySelector('.fsm-title').innerHTML = title;
		app.fsMsg.querySelector('.fsm-body').innerHTML = msg;

		app.fsMsg.querySelector('.fsm-footer').removeAttribute('hidden');

		if (obj) {
			if (obj.right) {
				app.fsMsg.querySelector('.fsm-footer button.btnRight').removeAttribute('hidden');
				app.fsMsg.querySelector('.fsm-footer button.btnRight').innerHTML = obj.right.label;
				app.fsMsg.querySelector('.fsm-footer button.btnRight').style.background = obj.right.color ? obj.right.color : '#1a73e8';
				app.fsMsg.querySelector('.fsm-footer button.btnRight').addEventListener('click', obj.right.action ? obj.right.action : app.closeFullscreenMsg);
			}
			
			if (obj.left) {
				app.fsMsg.querySelector('.fsm-footer button.btnLeft').removeAttribute('hidden');
				app.fsMsg.querySelector('.fsm-footer button.btnLeft').innerHTML = obj.left.label;
				app.fsMsg.querySelector('.fsm-footer button.btnLeft').style.background = obj.left.color ? obj.left.color : '#e81a5d';
				app.fsMsg.querySelector('.fsm-footer button.btnLeft').addEventListener('click', obj.left.action ? obj.left.action : app.closeFullscreenMsg);
			}
		}
		else {
			app.fsMsg.querySelector('.fsm-footer button.btnRight').removeAttribute('hidden');
			app.fsMsg.querySelector('.fsm-footer button.btnRight').innerHTML = 'OK';
			app.fsMsg.querySelector('.fsm-footer button.btnRight').style.background = '#1a73e8';
			app.fsMsg.querySelector('.fsm-footer button.btnRight').addEventListener('click', app.closeFullscreenMsg);
		}

		app.fsMsg.classList.add('fs-message--visible');
	};

	async function run() {

	};

	app.nextTick = function() {
		// run after registering Service Worker
		console.info("Running other functions after registering SW...");

		app.firstLoadFromHashIfAny();
	};

	app.firstLoadFromHashIfAny = function() {
		var v1 = app.getHashParam().hash;
		var v2 = document.querySelector("a[href='/" + v1 + "']");

		if (v2) 
			app.changeView('switch-'+v2.id, v2.innerHTML);
	};

	app.getState = function() {
		if (document.visibilityState === 'hidden') {
			return 'hidden';
		}
		if (document.hasFocus()) {
			return 'focused';
		}
		return 'not focused';
	};

	app.logStateChange = function(nextState) {
		var prevState = app.state;
		if (nextState !== prevState) {
			var timeBadge = new Date().toTimeString().split(' ')[0];
			console.info('' + timeBadge + ' State changed from ' + prevState + ' to ' + nextState + '.');

			app.state = nextState;
		}
	};

	app.onPageStateChange = function() {
		//app.logStateChange(app.getState())
	};

	app.getHashParam = function() {
		if (window.location.hash) {
			var tmp = window.location.hash.split('?')

			var result         = {};
					result['hash'] = tmp[0];

			if (tmp[1]) {
				tmp[1].split('&').reduce(function (result2, item) {
					var parts = item.split('=');
					result[parts[0]] = parts[1];
				}, {});
			}

			return result;
		}

		return { hash: null };
	};

	/*****************************************************************************
   *
   * Event listeners for UI elements
   *
   ****************************************************************************/
	
  document.getElementById('btnHome').addEventListener('click', function() {
    app.changeView();
  });

	document.getElementById('btnBackHome').addEventListener('click', function() {
    app.changeView();
  });

  document.getElementById('page0').addEventListener('click', function(e) {
		e.preventDefault();
		app.changeView();
	});

  document.getElementById('page1').addEventListener('click', function(e) {
		e.preventDefault();
		app.changeView('switch-'+this.id, this.innerHTML);
	});

	document.getElementById('page2').addEventListener('click', function(e) {
		e.preventDefault();
		app.changeView('switch-'+this.id, this.innerHTML);
	});

	document.getElementById('page3').addEventListener('click', function(e) {
		e.preventDefault();
		app.changeView('switch-'+this.id, this.innerHTML);
	});

  document.getElementById('menuAbout').addEventListener('click', app.showAboutDialog);

	app.popupBox.addEventListener('click', function() {
    app.togglePopupDialog(false);
  });

	app.toast.addEventListener('click', function(event) {
    if (event.target.classList.contains('clicktoreload'))
      document.location.reload();
  });

	document.getElementById('toggle').addEventListener('change', function() {
		if(this.checked) {
			app.subWebPush();
		}
		else {
			app.unregisterPush();
		}
	});

	document.getElementById('noinstallpwa').addEventListener('click', function() {
		app.installPromotion(false);
	});
	
	['pageshow', 'focus', 'blur', 'visibilitychange', 'resume'].forEach(function (type) {
		window.addEventListener(type, app.onPageStateChange, {capture: true});
	});

	// disable back function of the back button
	window.addEventListener('popstate', function() {
		history.pushState(null, document.title, location.href);
	});

  /*****************************************************************************
   *
   * Methods to update/refresh the UI
   *
   ****************************************************************************/

  app.hideMenu = function() {
    var menuElement = document.querySelector('.menu');
    var menuOverlayElement = document.querySelector('.menu__overlay');

    menuElement.style.transform = "translateX(-110%)";
    menuElement.classList.remove('menu--show');
    menuOverlayElement.classList.remove('menu__overlay--show');
    menuElement.addEventListener('transitionend', onTransitionEnd, false);
  };

  function onTransitionEnd() {
    var touchStartPoint;
    var menuElement = document.querySelector('.menu');
    var menuOverlayElement = document.querySelector('.menu__overlay');

    if (touchStartPoint < 10) {
      menuElement.style.transform = "translateX(0)";
      menuOverlayElement.classList.add('menu__overlay--show');
      menuElement.removeEventListener('transitionend', onTransitionEnd, false);
    }
  };

	var isTouchSupported = 'ontouchstart' in window;
  var evt = isTouchSupported ? 'touchend' : 'mouseup';

  // iOS
  document.ontouchmove = function(e) {
    e.preventDefault();
  };

  var scrollingDiv0 = document.getElementsByClassName('page0')[0];
  scrollingDiv0.addEventListener('touchmove', function(event) {
		event.stopPropagation();
  });

  var scrollingDiv1 = document.getElementsByClassName('page1')[0];
  scrollingDiv1.addEventListener('touchmove', function(event) {
    event.stopPropagation();
  });

  var scrollingDiv2 = document.getElementsByClassName('page2')[0];
  scrollingDiv2.addEventListener('touchmove', function(event) {
		event.stopPropagation();
  }); 

	var scrollingDiv3 = document.getElementsByClassName('page3')[0];
  scrollingDiv3.addEventListener('touchmove', function(event) {
    event.stopPropagation();
  });


	window.addEventListener('load', function() {
		console.group('[Starting App]');

		if (app.isLocalhost()) {
			// debugging
			document.querySelector('.header__title').addEventListener('click', function() {
				console.info(app.visibleEl);
			});
		}
		else {
			window.oncontextmenu = function(ev) {
				ev.preventDefault();
				ev.stopPropagation();
				return false;
			};
		}

		app.state = app.getState();

		console.info(app.isLocalhost() ? 'localhost' : 'internet');

		app.updateOnlineStatus();

		if (typeof(Storage) !== "undefined") {
			console.info("✔ 1) LocalStorage is supported.");
		}
		else {
			console.info("✘ 1) Your browser has no LocalStorage support.");

			document.getElementById('menuPush').classList.add("disabled");
			document.getElementById('toggle').setAttribute("disabled", "disabled");
		}

		if (!("Notification" in window)) {
			// Notification isn't supported on this browser, disable or hide UI.
			console.info("✘ 2) Your browser has no Notification support.");

			document.getElementById('menuPush').classList.add("disabled");
			document.getElementById('toggle').setAttribute("disabled", "disabled");
		}
		else {
			console.info("✔ 2) Notification is supported.");

			if (Notification.permission === "granted") {
				if (localStorage.getItem("subWebPush")==1)
					document.querySelector('#toggle').checked = true;
			}

		}

		if (!('PushManager' in window)) {
			// Push isn't supported on this browser, disable or hide UI.
			console.info("✘ 3) Your browser has no PushManager support.");

			document.getElementById('menuPush').classList.add("disabled");
			document.getElementById('toggle').setAttribute("disabled", "disabled");
		}
		else {
			console.info("✔ 3) PushManager is supported.");
		}

		if ("Notification" in window && "showTrigger" in Notification.prototype) {
			/* origin-trial - Notification Triggers supported */
			console.info("✔ 4) Notification Triggers is supported.");
		}
		else {
			console.info("✘ 4) Your browser has no Notification Triggers support.");
		}

		if (!('serviceWorker' in navigator)) {
			// Service Worker isn't supported on this browser, disable or hide UI.
			console.info("Service Worker isn't supported on this browser.");
		}
		else {
			console.info('Registering service worker...');

			run().then(app.nextTick);
		}

		if (app.isLoading) {
			app.spinner.setAttribute('hidden', true);

			app.isLoading = false;
		}

		console.groupEnd();

	});

})();
