﻿importScripts('https://storage.googleapis.com/workbox-cdn/releases/5.1.3/workbox-sw.js');

if (workbox) {
  console.log(`Yay! Workbox is loaded 🎉`);

  workbox.precaching.precacheAndRoute(self.__WB_MANIFEST);

	workbox.googleAnalytics.initialize();

} else {
  console.log(`Boo! Workbox didn't load 😬`);
}

self.addEventListener('install', function(e) {
  self.skipWaiting();

});

self.addEventListener('activate', function(e) {
  return self.clients.claim();

});

self.addEventListener('push', function(e) {
  const data = e.data.json();
  var options;

  if (data.url) {
    options = {
      body : data.body,
      badge: "./images/badges/notification_192.png",
      icon : "./images/icons/icon-192x192.png",
      vibrate: [100, 50, 100],
			data : {url: data.url},
      actions: [
        {
          action: 'web-action',
          title: 'Open web'
        }
      ]
    }
  }
  else {
    options = {
      body : data.body,
      badge: "./images/badges/notification_192.png",
      icon : "./images/icons/icon-192x192.png",
      vibrate: [100, 50, 100]
    }
  }

  self.registration.showNotification(data.title, options);
});

self.addEventListener('pushsubscriptionchange', function(e) {
  console.info('Subscription expired');

});

self.addEventListener('notificationclick', function(e) {
  if (!e.action) {
    // Was a normal notification click
    console.info('Notification Click.');
    return;
  }

  switch (e.action) {
    case 'web-action':
      e.notification.close();

      e.waitUntil(
        clients.openWindow(e.notification.data.url)
      );
      break;
  }
});
