(function() {
  'use strict';

  // credit: http://www.javascriptkit.com/javatutors/touchevents2.shtml
   function swipedetect(el, callback){

    var touchsurface = el,
    swipedir,
    startX,
    startY,
    dist,
    distX,
    distY,
    threshold = 120, //required min distance traveled to be considered swipe
    restraint = 100, // maximum distance allowed at the same time in perpendicular direction
    allowedTime = 300, // maximum time allowed to travel that distance
    elapsedTime,
    startTime,
    handleswipe = callback || function(swipedir){};

    touchsurface.addEventListener('touchstart', function(e){
    var touchobj = e.changedTouches[0];
      swipedir = 'none';
      dist = 0;
      startX = touchobj.pageX;
      startY = touchobj.pageY;
      startTime = new Date().getTime(); // record time when finger first makes contact with surface
    }, false);
/**
    touchsurface.addEventListener('touchmove', function(e){
      e.preventDefault() // prevent scrolling when inside DIV
    }, false);
**/
    touchsurface.addEventListener('touchend', function(e){
      if(e.changedTouches.length > 0) {
        var touchobj = e.changedTouches[0];
        distX = touchobj.pageX - startX; // get horizontal dist traveled by finger while in contact with surface
        distY = touchobj.pageY - startY; // get vertical dist traveled by finger while in contact with surface
        elapsedTime = new Date().getTime() - startTime; // get time elapsed
        if (elapsedTime <= allowedTime){ // first condition for awipe met
          if (Math.abs(distX) >= threshold && Math.abs(distY) <= restraint){ // 2nd condition for horizontal swipe met
            swipedir = (distX < 0)? 'left' : 'right'; // if dist traveled is negative, it indicates left swipe
          }
          else if (Math.abs(distY) >= threshold && Math.abs(distX) <= restraint){ // 2nd condition for vertical swipe met
            swipedir = (distY < 0)? 'up' : 'down'; // if dist traveled is negative, it indicates up swipe
          }
        }
        handleswipe(swipedir);
      }
    }, false);
  }

  var menuIconElement    = document.querySelector('.header__icon');
  var menuElement        = document.querySelector('.menu');
  var menuOverlayElement = document.querySelector('.menu__overlay');

  function showMenu() {
    menuElement.style.transform = "translateX(0)";
    menuElement.classList.add('menu--show');
    menuOverlayElement.classList.add('menu__overlay--show');
  }

  //USAGE:
  // swipedir contains either "none", "left", "right", "top", or "down"

  var e;
  try {
    e = new Event('touchend');
  }
  catch (error) {
    e = document.createEvent('TouchEvent');
    e.initEvent('touchend', true, true);
  }

  var main = document.querySelector('.page0');
  swipedetect(main, function(swipedir){
    if(swipedir=='right') {
      showMenu();
    }
  });

})();
