(function(exports) {
  'use strict';

  var toastContainer = document.querySelector('.toast__container');

  function toast(msg, options, clss) {
    if (!msg) return;

    options = options || 3000;
		clss = clss || '';

    var toastMsg = document.createElement('div');

    toastMsg.className = 'toast__msg toast__msg--visible ' + clss;
    toastMsg.innerHTML = msg;

    toastContainer.appendChild(toastMsg);

    //Show toast for 3secs and hide it
    setTimeout(function() {
      toastMsg.classList.remove('toast__msg--visible');
    }, options);

    //Remove the element after hiding
    toastMsg.addEventListener('transitionend', function(event) {
      event.target.parentNode.removeChild(event.target);
    });
  }

  exports.toast = toast; //Make this method available in global
})(typeof window === 'undefined' ? module.exports : window);
